﻿Imports System.Data.OleDb



Module Common
    Public Const cErrorApp As String = "MQROptions"
    Public Const cModTitle As String = "Q&R Options Editor"
    Public OptPropArray As OptProp()
    Public Structure OptProp
        Public OptProp_Category As String
        Public OptProp_PropertyName As String
        Public OptProp_ValueNum As Integer
        Public OptProp_DisplayName As String
        Public OptProp_PropertyType As String
        Public OptProp_CADefaultValue As String
        Public OptProp_SiteValue As String
        Public OptProp_UserValue As String
        Public OptProp_UIUpdateable As Boolean
        Public OptProp_MinLength As Integer
        Public OptProp_MaxLength As Integer
        Public OptProp_RangeLow As Integer
        Public OptProp_RangeHigh As Integer
        Public OptProp_InvalidCharStr As String
        Public OptProp_EditType As String
        Public OptProp_UserId As String
    End Structure
    Public OptColorArray As OptColor()
    Public Structure OptColor
        Public OptColor_Category As String
        Public OptColor_ElemName As String
        Public OptColor_ElemValue As String
        Public OptColor_Color As String
        Public OptColor_User As String
    End Structure
    Public OptAliasArray As OptAlias()
    Public Structure OptAlias
        Public OptAlias_ElemName As String
        Public OptAlias_Alias As String
    End Structure

    Public bDirtyFlag As Boolean = False

    Public hostName As String = ""
    Public OptionsDataPath As String

    Public optionsDBName As String
    Public cnSecString As String = "provider= microsoft.jet.oledb.4.0; data source=" & optionsDBName & ";"
    Public cn As New OleDbConnection(cnSecString)

    Public installPath As String
    Public clientInstallPath As String
    Public serverInstallPath As String
    Public serverDataPath As String
    '-- Public variables for the datasource and connection string for the access database.
    Public dataSource As String
    Public cnString As String
    '-- Define fonts for use on Panels
    Dim fontFamily As New FontFamily("Microsoft Sans Serif")
    Dim fontFamily1 As New FontFamily("Courier New")
    Dim fontsize1 As Integer = 9
    Dim fontsize2 As Integer = 12
    Dim fontsize3 As Integer = 10
    Dim txtfont As New Font(fontFamily, fontsize1, FontStyle.Regular, GraphicsUnit.Point)
    Dim treeviewfont As New Font(fontFamily, fontsize1, FontStyle.Bold, GraphicsUnit.Point)
    Dim datagridfont As New Font(fontFamily, fontsize1, FontStyle.Bold, GraphicsUnit.Point)
    Public datagridfont1 As New Font(fontFamily, fontsize1, FontStyle.Regular, GraphicsUnit.Point)
    Dim lblfont As New Font(fontFamily, fontsize1, FontStyle.Bold, GraphicsUnit.Point)
    Dim btnfont As New Font(fontFamily, fontsize1, FontStyle.Bold, GraphicsUnit.Point)
    Dim grpboxfont As New Font(fontFamily, fontsize1, FontStyle.Regular, GraphicsUnit.Point)
    Dim LstBoxfont As New Font(fontFamily, fontsize1, FontStyle.Bold, GraphicsUnit.Point)
    Dim PnlHdgfont As New Font(fontFamily, fontsize2, FontStyle.Bold, GraphicsUnit.Point)
    'Dim PnlHdgfont As New Font(fontFamily, fontsize1, FontStyle.Regular, GraphicsUnit.Point)
    Dim NonPropfont As New Font(fontFamily1, fontsize3, FontStyle.Bold, GraphicsUnit.Point)
    Public Structure fontStruct
        Public font_Family As String
        Public font_Size As Single ' Integer
        Public font_Bold As Boolean
        Public font_Italic As Boolean
        Public font_Underline As Boolean
        Public font_Strikethrough As Boolean
        Public font_style As Integer
        Public font_styleStr As String
    End Structure
    Public Sub SetFormFonts(ByRef TheControl As Control)
        On Error GoTo errhandle
        Dim StrControlType As String
        Dim i As Integer
        For i = 0 To TheControl.Controls.Count - 1
            'MsgBox(TheControl.Controls(i).GetType.Name.ToUpper & ":" & TheControl.Controls(i).Name)
            If TheControl.Controls(i).Tag <> "" Then
                StrControlType = TheControl.Controls(i).Tag.ToString.ToUpper  'allow the tag value to be the type if default not ok
            Else
                StrControlType = TheControl.Controls(i).GetType.Name.ToUpper
            End If
            Select Case StrControlType
                Case Is = "TEXTBOX"
                    TheControl.Controls(i).Font = txtfont
                Case Is = "LABEL"
                    If TheControl.Controls(i).ForeColor.Name.ToUpper = "BLUE" Then
                        TheControl.Controls(i).Font = PnlHdgfont
                        Debug.Print(TheControl.Controls(i).GetType.Name.ToUpper & ":" & TheControl.Controls(i).Name & ":" & TheControl.Controls(i).ForeColor.Name)
                    Else
                        TheControl.Controls(i).Font = lblfont
                    End If
                Case Is = "BUTTON"
                    TheControl.Controls(i).Font = btnfont
                Case Is = "GROUPBOX"
                    TheControl.Controls(i).Font = grpboxfont
                    SetFormFonts(TheControl.Controls(i)) '-- recursive call for subordinate controls
                Case Is = "DATAGRIDVIEW", "QRDATAGRIDVIEW"
                    TheControl.Controls(i).Font = datagridfont
                    TheControl.Controls(i).BackColor = System.Drawing.SystemColors.ActiveCaptionText
                Case Is = "LISTBOX"
                    TheControl.Controls(i).Font = LstBoxfont
                Case Is = "SPLITCONTAINER"
                    TheControl.Controls(i).Font = txtfont
                    Dim splContainer As SplitContainer = TheControl.Controls(i)
                    splContainer.BorderStyle = BorderStyle.FixedSingle
                    SetFormFonts(TheControl.Controls(i)) '-- recursive call for subordinate controls
                Case Is = "SPLITTERPANEL"
                    TheControl.Controls(i).Font = txtfont
                    SetFormFonts(TheControl.Controls(i)) '-- recursive call for subordinate controls
                Case Is = "PANEL"
                    TheControl.Controls(i).Font = txtfont
                    SetFormFonts(TheControl.Controls(i)) '-- recursive call for subordinate controls
                Case Is = "RADIOBUTTON"
                    TheControl.Controls(i).Font = txtfont
                Case Is = "COMBOBOX"
                    TheControl.Controls(i).Font = txtfont
                Case Is = "TREEVIEW"
                    TheControl.Controls(i).Font = treeviewfont
                Case Is = "TABCONTROL"
                    TheControl.Controls(i).Font = lblfont
                    SetFormFonts(TheControl.Controls(i)) '-- recursive call for subordinate controls
                Case Is = "TABPAGE"
                    TheControl.Controls(i).Font = lblfont
                    SetFormFonts(TheControl.Controls(i)) '-- recursive call for subordinate controls
                Case Is = "TOOLSTRIP"
                    'do nothing
                Case Is = "CHECKEDLISTBOX"
                    Dim ChkListbox As CheckedListBox = TheControl.Controls(i)
                    ChkListbox.BorderStyle = BorderStyle.Fixed3D
                    ChkListbox.HorizontalScrollbar = True
                    'do nothing
                Case Is = "DATETIMEPICKER"
                    Dim theDTP As DateTimePicker = TheControl.Controls(i)
                    theDTP.DropDownAlign = LeftRightAlignment.Right
                Case Is = "PICTUREBOX"
                    TheControl.Controls(i).Font = txtfont
                Case Is = "CHECKBOX"
                    TheControl.Controls(i).Font = txtfont
                Case Is = "NUMERICUPDOWN"
                    TheControl.Controls(i).Font = txtfont
                    Dim theNUD As NumericUpDown = TheControl.Controls(i)
                    theNUD.TextAlign = LeftRightAlignment.Right
                Case Is = "STATUSSTRIP"
                    TheControl.Controls(i).Font = lblfont
                Case Is = "CHART"
                    'font settings do not apply to the chart FX control
                Case Is = "NO CHANGE"
                    'do nothing
                Case Is = "NONPROPORTIONAL"
                    TheControl.Controls(i).Font = NonPropfont
                Case Is = "MENUSTRIP"
                    'do nothing
                Case Is = "FPSPREAD"
                    TheControl.Controls(i).Font = datagridfont1
                Case Else
                    MsgBox("Font settings not available for: " & TheControl.Controls(i).Name & " Type: " & TheControl.Controls(i).GetType.Name.ToUpper)
                    'do nothing
            End Select

        Next
        Exit Sub
errhandle:
        MsgBox("Font settings not available for: " & TheControl.Controls(i).Name & " Type: " & TheControl.Controls(i).GetType.Name.ToUpper)


    End Sub
    Public Function Error_MsgBox(ByVal sSource As String, ByVal sIntroText As String, _
                        ByVal strECode As String, Optional ByVal sFollowText As String = "", _
                        Optional ByVal iMsgIcon As Integer = 99, Optional ByVal strBoxTitle As String = cModTitle, _
                        Optional ByVal strEHFile As String = "", Optional ByVal strEHCtx As String = "") As Integer

        Dim sMessage As String
        If iMsgIcon = 99 Then
            iMsgIcon = vbExclamation & vbOKOnly  ' Can't be default in arguement list
        End If

        If Mid(Err.Description, 1, 5) = cErrorApp Then
            Err.Description = Mid(Err.Description, 6) 'get back to original error description
        Else   'error occurred in this module
            Err.Source = sSource
        End If
        Beep()

        If Err.Source <> "" Then
            If Err.Number <> 0 Then
                sMessage = Space(5) & strECode & ": " & vbNewLine & _
                    "     Error:  " & Err.Number & " " & Err.Description & vbNewLine & _
                    "     " & sIntroText & vbNewLine & _
                    "     Source:  " & Err.Source
            Else
                sMessage = Space(5) & strECode & ": " & vbNewLine & _
                    Space(5) & sIntroText & vbNewLine & _
                    Space(5) & Err.Description & vbNewLine & _
                    "     Source:  " & Err.Source
            End If
        Else
            If Err.Number <> 0 Then
                sMessage = Space(5) & strECode & ": " & vbNewLine & _
                    "     " & sIntroText & vbNewLine & _
                    "     Error:  " & Err.Number & " " & Err.Description & vbNewLine
            Else
                sMessage = Space(5) & strECode & ": " & vbNewLine & _
                    Space(5) & sIntroText & vbNewLine & _
                    Space(5) & Err.Description & vbNewLine
            End If
        End If

        If sFollowText <> "" Then
            sMessage = sMessage & vbNewLine & Space(5) & sFollowText
        End If

        If strEHFile <> "" Or strEHCtx <> "" Then
            Error_MsgBox = MsgBox(sMessage, iMsgIcon, strBoxTitle) ' strEHFile, strEHCtx)
        Else
            Error_MsgBox = MsgBox(sMessage, iMsgIcon, strBoxTitle)
        End If

        Err.Clear()
        Exit Function
    End Function
    Public Sub SQLExceptionManager(ByVal theException As Exception, ByVal modname As String, ByVal rtnName As String, _
                                   ByVal cmd As OleDbCommand, ByVal StrInfo As String)
        Dim errtype As System.Type
        errtype = theException.GetType
        Dim strInfoText As String = ""
        If StrInfo.Length > 0 Then
            strInfoText = vbCrLf & StrInfo
        End If

        Select Case errtype.Name.ToUpper
            Case "OleDbException".ToUpper()
                Error_MsgBox(modname & ":" & rtnName, "Unable to execute cmd: " & cmd.CommandText & strInfoText, "MQR1009E")
                Exit Sub
            Case "InvalidOperationException".ToUpper()
                Error_MsgBox(modname & ":" & rtnName, "Invalid Operation detected. Unable to execute cmd: " & cmd.CommandText & strInfoText, "MQR1009E")
                Exit Sub
            Case "Exception".ToUpper()
                Error_MsgBox(modname & ":" & rtnName, theException.Message.ToString & strInfoText, "MQR1000E")
                Exit Sub
            Case Else
                Error_MsgBox(modname & ":" & rtnName, errtype.Name & " Detected" & vbCrLf & theException.Message.ToString & strInfoText, "MQR1000E")
                Exit Sub

        End Select
    End Sub
    Public Function statusBarMsg(ByVal msgNum As String, ByVal msgText As String, Optional ByVal timerInt As Integer = 8000) As Boolean
        If (msgNum = "" Or msgNum.EndsWith(":")) Then
            frmMQROptions.ttsMessage.Text = msgNum & " " & msgText
        Else
            frmMQROptions.ttsMessage.Text = msgNum & ": " & msgText
        End If

        If timerInt <> 8000 Then
            frmMQROptions.tmrMessage.Interval = timerInt
        End If
        frmMQROptions.tmrMessage.Enabled = True
        statusBarMsg = True
    End Function
    Public Function Parse(ByVal Source As String, ByVal separator As String, _
                ByVal wordnum As Integer) As String
        'Parse breaks string Source down into words using the
        'separator character and returns the nth word as requested using
        'wordnum.  Leading and trailing blanks are stripped off of
        'the returned string.
        'An empty string("") is returned if there are less than
        'wordnum words in the string.

        Dim i As Integer, seplen As Integer, seplocation As Integer
        Dim vc_len As Integer

        On Error GoTo BadParse

        For i = 1 To wordnum - 1
            seplocation = InStr(1, Source, separator)
            If seplocation = 0 Then
                Parse = ""
                Exit Function
            Else
                Source = Mid(Source, seplocation + 1)
            End If
        Next i

        i = InStr(1, Source, separator)
        If i = 0 Then
            Parse = Trim(Source)
        Else
            If separator <> ";" Then
                Parse = Trim(Mid(Source, 1, i - 1))
            Else  'do only when separator is a ; (use for all cases in SP2 - dance01 12/14/2007)
                If InStr(1, Source, "<mqrVIPackage>") = 2 Then
                    vc_len = InStr(1, Source, "</mqrVIPackage>")
                    If vc_len > 0 Then
                        Parse = Trim(Mid(Source, 1, vc_len + 16))
                    Else
                        Parse = Trim(Mid(Source, 1, i - 1))
                    End If
                Else
                    Parse = Trim(Mid(Source, 1, i - 1))
                End If
            End If

        End If
        Exit Function

BadParse:
        ''Error_Raise("Common:Parse")
        Exit Function

    End Function
    Public Function IsLoaded(ByVal FormName As String) As Boolean
        On Error GoTo errhandle
        Select Case (FormName)
            Case "frmMQMOptions"
                If frmMQROptions.Visible = True Then
                    IsLoaded = True
                    Exit Function
                End If
        End Select
        IsLoaded = False
        Exit Function
errhandle:
        IsLoaded = False
    End Function
    Public Function loadFont(ByRef fontField As String, ByRef fontList As fontStruct) As Boolean

        Dim i As Integer
        'To Do: fix fonts
        'default font values - until font as working better
        fontList.font_Size = 9
        fontList.font_Bold = False
        fontList.font_Italic = False

        Try
            Dim tempArray() As String = fontField.Split(",")
            For i = 0 To tempArray.Length - 1
                Select Case i
                    Case 0
                        fontList.font_Family = tempArray(0)
                    Case 1
                        fontList.font_Size = tempArray(1)
                    Case 2
                        fontList.font_Bold = Convert.ToBoolean(tempArray(2))
                    Case 3
                        fontList.font_Italic = Convert.ToBoolean(tempArray(3))
                End Select
            Next
        Catch ex As Exception
            MsgBox("error in load font")
        End Try

        Return True


    End Function
    Public Function getFontStyleInt(FontBold As Boolean, FontItalic As Boolean, FontUnderline As Boolean) As Integer
        Dim fontInt As Integer
        Try

            If FontBold = True Then
                fontInt = fontInt Or FontStyle.Bold
            End If

            If FontItalic = True Then
                fontInt = fontInt Or FontStyle.Italic
            End If

            If FontUnderline = True Then
                fontInt = fontInt Or FontStyle.Underline
            End If
            getFontStyleInt = fontInt
        Catch
            'any error - return FontStyle.Regular
            getFontStyleInt = FontStyle.Regular
        End Try
    End Function
End Module
