﻿Imports Microsoft.Win32
'-- Required to Elevate Security Permissions
Imports System.Security
Imports System.Security.Principal
Imports System.Security.Permissions

Module MQRAdminBAS
    Public blnServIsOld As Boolean      'Flag for old Q&R Distributed Server
    Public QRServerVer As String
    Public isConnected As Boolean
    Public isValidServer As Boolean
    Public bShowSvrComm As Boolean

    Public serverUpDownStatus As String

    Public AdminUserID As String

    Public gcurrentIP As String
    Public gcurrentPort As String

    Public mustReadINI As Boolean = True
    Public IniFileMQROptions As String '-- path & file name of the MQROptions.ini file

    Const caREGKEYINFO As String = "SOFTWARE\CA\MICS\MQR Workstation\CurrentVersion"
    Const caREGVALSERVER As String = "Client Data Path"

    Public Sub getINIPath()
        Dim success As Boolean
        Dim options As String = ""

        success = GetKeyValue(caREGKEYINFO, caREGVALSERVER, options)
        If success Then
            If Mid(options, options.Length - 1, 1) <> "\" Then
                options = options & "\"
            End If
        Else
            options = ""
        End If

        ' store path(s) and file name(s) to the ini file(s)
        IniFileMQROptions = options & "MQROptions.ini"
    End Sub
    Public Function GetKeyValue(ByRef keyName As String, ByRef SubKeyRef As String, ByRef KeyVal As String) As Boolean
        Dim pRegKey As RegistryKey = Registry.LocalMachine
        Try
            pRegKey = pRegKey.OpenSubKey(keyName)
            KeyVal = pRegKey.GetValue(SubKeyRef)
            GetKeyValue = True
        Catch ex As Exception
            GetKeyValue = False
        End Try
    End Function
    Function initializeVariables(ByRef cnstring As String, ByRef datasource As String) As Boolean
        '-- Read up registry values
        If Not readRegistry("Install Path", installPath) Then
            initializeVariables = False
            Exit Function
        Else
            initializeVariables = True
        End If
        If Not readRegistry("Client Install Path", clientInstallPath) Then
            initializeVariables = False
            Exit Function
        Else
            initializeVariables = True
        End If
        If Not readRegistry("Server Install Path", serverInstallPath) Then
            initializeVariables = False
            Exit Function
        Else
            initializeVariables = True
        End If
        If Not readRegistry("Server Data Path", serverDataPath) Then
            initializeVariables = False
            Exit Function
        Else
            initializeVariables = True
        End If

        '-- Read MICSQR.ini
        DoProfile()

        '-- Initialze the datasource and connection string here so it is available throught
        '-- the whole application and can be changed in a single place if it needs to be.
        '-- Has to be done after the serverDataPath is retrieved.
        datasource = serverDataPath & "\" & "mqroptions.accdb"
        'cnstring = "provider= microsoft.jet.oledb.4.0; data source=" & datasource & ";"
        cnstring = "provider=Microsoft.ACE.OLEDB.12.0; data source=" & datasource & ";"

    End Function
    Function readRegistry(ByRef key As String, ByRef path As String) As Boolean

        '-- Perform Registry reads
        Dim RegPathKey As String = "HKEY_LOCAL_MACHINE\SOFTWARE\CA\MICS\MQR Workstation\CurrentVersion"
        Dim DefVersion = New Object()

        readRegistry = True

        Try
            path = Registry.GetValue(RegPathKey, key, DefVersion)
        Catch ae As ArgumentException
            readRegistry = False
            Exit Function
        Catch e As Exception
            readRegistry = False
            Exit Function
        End Try
    End Function
    Function IsWindows7(ByRef osVerStr As String) As Boolean
        '-- Determing if the operating system is Windows 7
        '-- if it isn't windows 7 we don't care
        Dim rtnName As String = "IsWindows7"
        Dim osVer As System.OperatingSystem = System.Environment.OSVersion
        osVerStr = osVer.VersionString
        If osVer.Version.Major >= 6 And osVer.Version.Minor >= 1 Then
            IsWindows7 = True
            Exit Function
        Else
            'running something lower
            IsWindows7 = False
            Exit Function

        End If
    End Function
    Private Function AdminElevate(ByVal args As String)
        If Not IsRunAsAdmin() Then
            '-- Re-launch the program as administrator
            Dim psinfo As New ProcessStartInfo()
            psinfo.UseShellExecute = True
            psinfo.WorkingDirectory = Environment.CurrentDirectory
            psinfo.FileName = Application.ExecutablePath
            psinfo.Arguments = args
            psinfo.Verb = "runas"

            Try
                Process.Start(psinfo)
            Catch ex As Exception
                Return False
            End Try
            Application.Exit()
            System.Environment.Exit(0)
        End If
        Return True

    End Function
    Friend Function IsRunAsAdmin() As Boolean
        Dim principal As New WindowsPrincipal(WindowsIdentity.GetCurrent)
        Return principal.IsInRole(WindowsBuiltInRole.Administrator)
    End Function
End Module
