﻿Imports System.IO

Module MQRQueryINI

    Public gUserID As String            'The Current User

    Public varFiles() As String ' Varible to store the returned array.

    Private prvName As String
    Private QPath() As String
    Public blIOException As Boolean = False

    Private Const cINIServerSection = "Server"

    '[Server]
    Private iniIPAddr As String = "LocalHost"
    Private iniPortNum As String = "20368"

    Public emptyStr As String = ""
    Public defaultProfile As String() = { _
            "[Server]", _
            "IP Address=" & iniIPAddr, _
            "Port=" & iniPortNum}

    'Public bMQRQueryDebugSwitch As Boolean

    Public Sub DoProfile(Optional ByVal justRead As Boolean = False)

        'Dim AppPath As String
        'AppPath = Application.StartupPath
        IniFileMQROptions = OptionsDataPath & "MQROptions.ini"
        'getINIPath()
        If justRead = False Then
            For i As Integer = 0 To defaultProfile.Length - 1
                fillProfile(defaultProfile(i))
            Next
            'Exit Sub
        End If
        Dim bwriteNewFile As Boolean = True

        If (File.Exists(IniFileMQROptions)) Then
            bwriteNewFile = False
            ' Open the file to read from.
            Dim sr = New StreamReader(IniFileMQROptions)
            Dim INI_line As String
            Do While Not sr.EndOfStream
                INI_line = sr.ReadLine()
                fillProfile(INI_line)
            Loop
            sr.Close()
        End If
        If bwriteNewFile = True Then
            ' Create Profile
            Try

                If (Directory.Exists(OptionsDataPath)) Then
                Else
                    Directory.CreateDirectory(OptionsDataPath)
                End If
                Try
                    File.WriteAllLines(IniFileMQROptions, defaultProfile)
                Catch ex As Exception
                    MsgBox(ex.Message & " Trying to write INI file")
                End Try
            Catch E As Exception
                MsgBox("Error creating directory " & OptionsDataPath & vbCrLf & E.Message)
            End Try

        End If

    End Sub   ' end DoProfile

    Public Sub WriteProfile()

        If mustReadINI = True Then
            DoProfile(True)  ' Read Only
            mustReadINI = False
        End If
        Try
            File.WriteAllLines(IniFileMQROptions, defaultProfile)
        Catch ex As IOException
            blIOException = True
            MsgBox("MQR1000E: " & ex.Message)
        End Try

    End Sub   ' end DoProfile

    Public Function findProfileIndex(ByVal item As String) As Integer
        Dim index As Integer
        For index = 0 To defaultProfile.Count - 1
            If defaultProfile(index).ToUpper.StartsWith(item.ToUpper) Then
                findProfileIndex = index
                Exit Function
            End If
        Next
        index = -1
        Return True
    End Function

    Public Sub fillProfile(ByRef profileTarget As String)


        Dim parts() As String
        parts = profileTarget.Split("=")

        If parts.Length > 1 Then

            Select Case parts(0)
                Case "IP Address"
                    iniIPAddr = parts(1).TrimEnd()
                    defaultProfile(findProfileIndex("IP Address=")) = "IP Address=" & iniIPAddr
                Case "PortNum"
                    iniPortNum = CInt(parts(1))
                    defaultProfile(findProfileIndex("PortNum=")) = "PortNum=" & iniPortNum
            End Select
        End If

    End Sub  ' end DoProfile

    Function getINIPortNum() As String
        getINIPortNum = iniPortNum
    End Function

    Function getINIIPAddress() As String
        getINIIPAddress = iniIPAddr
    End Function
    
    Function setINIPortNum(ByRef portNum As String) As String
        iniPortNum = portNum
        defaultProfile(findProfileIndex("Port=")) = "Port=" & iniPortNum
        WriteProfile()
        Return True
    End Function
    Function setINIIPAddress(ByRef IPAddress As String) As String
        iniIPAddr = IPAddress
        defaultProfile(findProfileIndex("IP Address=")) = "IP Address=" & iniIPAddr
        WriteProfile()
        Return True
    End Function
    
End Module
