﻿Option Strict Off
Option Explicit On

Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports System.Linq
Imports System.Runtime.Serialization.DataContractSerializer
Imports System.Xml.Serialization 'added for Propertyval Class

'
Namespace MQROptions
    <Table(Name:="PropertyDef")>
          Public Class PropertyDef
        '  /* Class representing an PropertyDef Table in the Options Database. */
        'Name field in column statement - i.e. <Column(Name:PanelID) is not needed 
        'because it is assumed to be the same as the field
        <Column(CanBeNull:=True)> Public category As String
        <Column(CanBeNull:=True)> Public propertyName As String
        <Column(CanBeNull:=True)> Public valueNum As Nullable(Of Integer)
        <Column(CanBeNull:=True)> Public displayName As String
        <Column(CanBeNull:=True)> Public propertyType As String
        <Column(CanBeNull:=True)> Public CADefaultValue As String
        <Column(CanBeNull:=True)> Public UIUpdateable As Boolean
        <Column(CanBeNull:=True)> Public MinLength As Nullable(Of Integer)
        <Column(CanBeNull:=True)> Public MaxLength As Nullable(Of Integer)
        <Column(CanBeNull:=True)> Public RangeLow As Nullable(Of Integer)
        <Column(CanBeNull:=True)> Public RangeHigh As Nullable(Of Integer)
        <Column(CanBeNull:=True)> Public InvalidCharStr As String
        <Column(CanBeNull:=True)> Public EditType As String

    End Class

        <Table(Name:="EditList")>
        Public Class EditList
            '  /* Class representing EditList Table in the Options Database. */
            <Column()> Public ListName As String
            <Column()> Public ValidValue As String
    End Class
    '<Table(Name:="MultiVal")>
    'Public Class MultiVal
    ''  /* Class representing MultiVal Table in the Options Database. */
    '<Column()> Public category As String
    '<Column()> Public propertyName As String
    '<Column()> Public PropertyValue1 As String
    '<Column()> Public PropertyValue2 As String
    '<Column()> Public PropertyValue3 As String
    '<Column()> Public User As String
    'End Class
        <Table(Name:="SingleVal")>
        Public Class SingleVal
        '  /* Class representing SingleVal Table in the Options Database. */
        <Column()> Public category As String
        <Column()> Public propertyName As String
        <Column()> Public PropertyValue1 As String
        <Column()> Public User As String
        End Class
    <Table(Name:="Categories")>
    Public Class Categories
        '  /* Class representing Categories Table in the Options Database. */
        <Column()> Public SeqNum As Integer
        <Column()> Public subCategory As String
        <Column()> Public subCategoryName As String
        <Column()> Public subCategoryDescription As String
        <Column()> Public DisplayuserVals As Boolean
    End Class

    'this is a subset of the optProp structure - this is not a table in the database
    <Table(Name:="OptProperties")>
        Public Class OptProperties
        <Column(CanBeNull:=True)> Public Category As String
        <Column(CanBeNull:=True)> Public PropertyName As String
        <Column(CanBeNull:=True)> Public ValueNum As Nullable(Of Integer)
        <Column(CanBeNull:=True)> Public PropertyType As String
        <Column(CanBeNull:=True)> Public CADefaultValue As String
        <Column(CanBeNull:=True)> Public SiteValue As String
        <Column(CanBeNull:=True)> Public UserValue As String
        <Column(CanBeNull:=True)> Public UserId As String
    End Class
    
End Namespace
'This class represents a collection of propertyval items 
<System.CodeDom.Compiler.GeneratedCodeAttribute("xsd", "4.0.30319.1"), _
System.SerializableAttribute(), _
System.Diagnostics.DebuggerStepThroughAttribute(), _
System.ComponentModel.DesignerCategoryAttribute("code"), _
System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True), _
System.Xml.Serialization.XmlRootAttribute([Namespace]:="", IsNullable:=False)> _
Partial Public Class drPropertyVal

    Private propertyValField() As PropertyVal
    Private generatedField As Date
    Private generatedFieldSpecified As Boolean

    <System.Xml.Serialization.XmlElementAttribute("PropertyVal")> _
     Public Property PropertyVal() As PropertyVal()
        Get
            Return Me.propertyValField
        End Get
        Set(value As PropertyVal())
            Me.propertyValField = value
        End Set
    End Property

    <System.Xml.Serialization.XmlAttributeAttribute()> _
        Public Property generated() As Date
        Get
            Return Me.generatedField
        End Get
        Set(value As Date)
            Me.generatedField = value
        End Set
    End Property

    <System.Xml.Serialization.XmlIgnoreAttribute()> _
    Public Property generatedSpecified() As Boolean
        Get
            Return Me.generatedFieldSpecified
        End Get
        Set(value As Boolean)
            Me.generatedFieldSpecified = value
        End Set
    End Property
    Public Sub PrintClassToDbg()
        Dim i As Integer

        For i = 0 To PropertyVal.Count - 1
            Debug.WriteLine("-----------------")
            Debug.WriteLine("PropertyValItem:" & i)
            propertyValField(i).DbgPrint()
        Next
    End Sub

End Class

<System.CodeDom.Compiler.GeneratedCodeAttribute("xsd", "4.0.30319.1"), _
 System.SerializableAttribute(), _
 System.Diagnostics.DebuggerStepThroughAttribute(), _
 System.ComponentModel.DesignerCategoryAttribute("code"), _
 System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True), _
 System.Xml.Serialization.XmlRootAttribute([Namespace]:="", IsNullable:=False)> _
Partial Public Class PropertyVal

    Public Category As String
    Public PropertyName As String
    Public ValueNum As Integer
    Public PropertyType As String
    Public CADefaultValue As String
    Public SiteValue As String
    Public UserValue As String
    Public UserID As String
    Public Sub DbgPrint()
        Debug.Print("Category:" & Category)
        Debug.Print("PropertyName:" & PropertyName)
        Debug.Print("ValueNum: " & ValueNum)
        Debug.Print("PropertyType: " & PropertyType)
        Debug.Print("CADefaultValue: " & CADefaultValue)
        Debug.Print("SiteValue: " & SiteValue)
        Debug.Print("UserValue: " & UserValue)
        Debug.Print("UserId: " & UserID)
    End Sub
End Class



