﻿Imports System.Data.OleDb
Imports System.Xml.Serialization
Imports System.IO
Imports System.Net
Imports System.Runtime.Serialization.Formatters.Binary

Imports System.Xml
Imports System.Xml.XmlWriter
Imports System.Xml.XmlReader
Imports FarPoint.Win.Spread.SubEditorOpeningEventArgs
Imports FarPoint.Win.Spread.CellType

Imports MQRCommon
Public Class frmINIOptions
    Private modName As String = "frmINIOptions"


    '-- Grid Column Reference Numbers
    Private grdPropNameCol As Integer = 0
    Private grdDeliveredCol As Integer = 1
    Private grdGlobalCol As Integer = 2
    Private grdOverrideCol As Integer = 3
    Private grdGlobalChgCol As Integer = 4
    Private grdUserChgCol As Integer = 5

    Private displayUserVals As Boolean
    Private displayedCols As Integer = 3

    Private CategoryRow As Options.CategoriesRow

    Public Structure fontStruct
        Public font_Family As String
        Public font_Size As Single ' Integer
        Public font_Bold As Boolean
        Public font_Italic As Boolean
        Public font_Underline As Boolean
        Public font_Strikethrough As Boolean
        Public font_style As Integer
        Public font_styleStr As String
    End Structure

    'Public Structure OptProp
    '    Public OptProp_Category As String
    '    Public OptProp_PropertyName As String
    '    Public OptProp_ValueNum As Integer
    '    Public OptProp_DisplayName As String
    '    Public OptProp_PropertyType As String
    '    Public OptProp_CADefaultValue As String
    '    Public OptProp_SiteValue As String
    '    Public OptProp_UserValue As String
    '    Public OptProp_UIUpdateable As Boolean
    '    Public OptProp_MinLength As Integer
    '    Public OptProp_MaxLength As Integer
    '    Public OptProp_RangeLow As Integer
    '    Public OptProp_RangeHigh As Integer
    '    Public OptProp_InvalidCharStr As String
    '    Public OptProp_EditType As String
    '    Public OptProp_UserId As String
    'End Structure

    Public Sub showform(ByRef sender As Form, ByRef inCategoryRow As Options.CategoriesRow)
        CategoryRow = inCategoryRow

        sender.ControlBox = False
        sender.FormBorderStyle = FormBorderStyle.None
        sender.ShowInTaskbar = False
        sender.TopLevel = False
        sender.Visible = True

        frmMQROptions.splContainer.Panel2.Controls.Clear()
        frmMQROptions.splContainer.Panel2.Controls.Add(sender)
    End Sub
    Private Sub frmINIOptions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SetFormFonts(Me)

        'Me.Size = New Size(frmMQROptions.splContainer.Panel2.ClientSize)

        fpsProperties.Width = Me.Width - 25

        If initializeQueryTab() = False Then
            Exit Sub
        End If
    End Sub

    Private Function initializeQueryTab() As Boolean
        Dim rtnName As String = "initializeQueryTab"

        initializeQueryGrid()
        readQueryGrid()
        Return True
    End Function
    Private Function initializeQueryGrid() As Boolean
        Dim rtnName As String = "initializeQueryGrid"
        Dim currentUser As String = Environment.UserName

        '-- Set the number of columns to 5 and the number of rows to 0 so we end up with exactly the number of rows we want
        fpsProperties.ActiveSheet.ColumnCount = 6
        fpsProperties.ActiveSheet.RowCount = 0
        'fpsProperties.BorderStyle = BorderStyle.FixedSingle

        '-- Turn on autosort for all the columns
        For i As Integer = 0 To fpsProperties.ActiveSheet.Columns.Count - 1
            fpsProperties.ActiveSheet.Columns(i).AllowAutoSort = True
            fpsProperties.ActiveSheet.ColumnHeader.Columns(i).Font = New Font(DefaultFont, FontStyle.Bold)
        Next
        'fpsProperties.EditModePermanent = True

        fpsProperties.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.Never
        fpsProperties.VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded

        fpsProperties.ActiveSheet.RowHeaderVisible = False

        Dim text As New FarPoint.Win.Spread.CellType.TextCellType
        text.WordWrap = True

        '-- Freeze first column so it doesn't scroll off the screen
        fpsProperties.ActiveSheet.FrozenColumnCount = 1

        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdPropNameCol).Label = "Option"
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdPropNameCol).Resizable = True
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdPropNameCol).Width = 160
        'fpsProperties.ActiveSheet.ColumnHeader.Columns(grdPropNameCol).CellType = text

        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdDeliveredCol).Label = "Default Values"
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdDeliveredCol).Resizable = True
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdDeliveredCol).Width = 175
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdDeliveredCol).Visible = False

        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdGlobalCol).Label = "Global Values for " & hostName
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdGlobalCol).Width = 175
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdGlobalCol).Resizable = True
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdGlobalCol).Visible = True
        'fpsProperties.ActiveSheet.Columns(grdGlobalChgCol).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
        'fpsProperties.ActiveSheet.ColumnHeader.Columns(grdGlobalCol).CellType = text

        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdOverrideCol).Label = "Overrides for " & Environment.UserDomainName & "\" & currentUser.ToUpper
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdOverrideCol).Width = 175
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdOverrideCol).Resizable = True
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdOverrideCol).Visible = True
        'fpsProperties.ActiveSheet.Columns(grdOverrideCol).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
        'fpsProperties.ActiveSheet.ColumnHeader.Columns(grdOverrideCol).CellType = text

        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdGlobalChgCol).Visible = False
        fpsProperties.ActiveSheet.ColumnHeader.Columns(grdUserChgCol).Visible = False
        fpsProperties.ActiveSheet.ColumnHeader.Rows(0).Height = 40

        '-- Set up alternating row Colors
        fpsProperties.ActiveSheet.AlternatingRows.Count = 2
        'fpsProperties.ActiveSheet.AlternatingRows(1).BackColor = Color.FromKnownColor(KnownColor.ButtonFace)
        fpsProperties.ActiveSheet.AlternatingRows(1).BackColor = Color.AntiqueWhite

        '-- Set Sheet background color
        fpsProperties.ActiveSheet.GrayAreaBackColor = Color.FromKnownColor(KnownColor.ButtonFace)

        Return True
    End Function
    Private Function readQueryGrid() As Boolean
        Dim rtnName As String = "readQueryGrid"

        Dim sqlStatement As String = ""
        Dim cmd As New OleDbCommand
        Dim dr As OleDbDataReader
        lblTitle.Text = CategoryRow.categoryDescription



        'Dim drow As DataRow
        'Dim subCategory As String = ""   '-- Made Global

        '-- Get the SubCategory Information for the Header 
        'sqlStatement = "SELECT * FROM [Categories] where [CategoryName] = '" & frmMQROptions.lsbMenu.SelectedItem & "'"

        'Try
        '    cmd.Connection = cn
        '    cmd.CommandText = sqlStatement
        '    If cn.State = ConnectionState.Closed Then
        '        cn.Open()
        '    End If
        '    dr = cmd.ExecuteReader
        '    If dr.HasRows = True Then
        '        While (dr.Read())
        '            Category = dr("Category").ToString
        '            lblTitle.Text = dr("CategoryDescription")
        '            displayUserVals = dr("DisplayUserVals")
        '        End While
        '    End If
        'Catch ode As OleDbException
        '    SQLExceptionManager(ode, modName, rtnName, cmd, "Connection String: " & cn.ConnectionString)
        '    cn.Close()
        '    Return False
        'Catch ex As Exception
        '    SQLExceptionManager(ex, modName, rtnName, cmd, "Connection String: " & cn.ConnectionString)
        '    cn.Close()
        '    Return False
        'Finally
        '    cn.Close()
        'End Try
        '-- End

        '-- Display correct image
        Select Case CategoryRow.category
            Case "MQRQueryIni"
                pbxImage.Image = My.Resources.query_setting_32
            Case "MICSQRIni"
                pbxImage.Image = My.Resources.server_setting_32
            Case "UtilityIni"
                pbxImage.Image = My.Resources.utility_setting_32
        End Select


        '-- Determine if the User Column should be displayed, if not hide it.
        If CategoryRow.displayUserVals = False Then
            fpsProperties.ActiveSheet.ColumnHeader.Columns(grdOverrideCol).Visible = False
            displayedCols = 2
        End If

        '-- Calcuate column width based on displayed columnes
        calculateColWidth()
        Dim strcategory As String = CategoryRow.category '"QRChart"
        Dim struser As String = "*GLOBAL*"
        Dim StrOptionsEdit As String

        'StrChartOptions = svrGetOptions("QRChart", "TANT-A01\DANCE01")

        StrOptionsEdit = frmServerComm.svrGetOptionsEdit(strcategory, "*GLOBAL*", "SINGLE")  'Q&R 12.7 Global user only

        Dim opted As Options.OptionEditable()
        opted = Utils.DeserializeInstance(Of Options.OptionEditable())(StrOptionsEdit)


        ReDim OptPropArray(0)
        If opted.Length = 0 Then
            loadQueryGrid(OptPropArray, 0, opted(0).property.editList)             'show a line if no entries for that category
        End If

        Dim bfirst As Boolean = True
        Dim i As Integer
        For Each optioneditable In opted
            If opted.Count > 0 Then
                If optioneditable.property.uiUpdateable = True Then 'only use them if UIUpdateable is true
                    If bfirst = True Then
                        i = 0
                        bfirst = False
                    Else
                        i = i + 1
                    End If
                    ReDim Preserve OptPropArray(i)
                    OptPropArray(i).OptProp_Category = strcategory
                    OptPropArray(i).OptProp_PropertyName = optioneditable.property.propertyName
                    OptPropArray(i).OptProp_CADefaultValue = optioneditable.caDefaultValue
                    OptPropArray(i).OptProp_UserId = struser
                    OptPropArray(i).OptProp_SiteValue = optioneditable.globalValue
                    OptPropArray(i).OptProp_UserValue = optioneditable.userValue
                    OptPropArray(i).OptProp_DisplayName = optioneditable.property.displayName
                    OptPropArray(i).OptProp_PropertyType = optioneditable.property.propertyType
                    OptPropArray(i).OptProp_EditType = optioneditable.property.editType
                    OptPropArray(i).OptProp_InvalidCharStr = optioneditable.property.invalidCharStr
                    OptPropArray(i).OptProp_MaxLength = optioneditable.property.maxLength.GetValueOrDefault
                    OptPropArray(i).OptProp_MinLength = optioneditable.property.minLength.GetValueOrDefault
                    OptPropArray(i).OptProp_RangeHigh = optioneditable.property.rangeHigh.GetValueOrDefault
                    OptPropArray(i).OptProp_RangeLow = optioneditable.property.rangeLow.GetValueOrDefault
                    OptPropArray(i).OptProp_UIUpdateable = optioneditable.property.uiUpdateable
                    loadQueryGrid(OptPropArray, i, optioneditable.property.editList)             'OptPropArray.Count - 1)  'last entry
                End If
            End If
        Next
        ' loadQueryGrid(OptPropArray, OptPropArray.Count - 1)  'last entry
        Return True
        '-- Actually Read the information to load the grid based on the Subcategory
        'sqlStatement = "SELECT * FROM [PropertyDef] " & _
        '               "WHERE [Category] = '" & Category & "' and [UIUpdateable] = True" & _
        '                " order by  [PropertyName]  "

        '' Dim i As Integer = 0

        'Dim rowCount As Integer = 0
        'ReDim OptPropArray(0)
        'Dim propVal As New drPropertyVal

        'cmd.Connection = cn
        'cmd.CommandText = sqlStatement
        'If cn.State = ConnectionState.Closed Then
        '    cn.Open()
        'End If
        'Dim currentDomain As String = Environment.UserDomainName
        'Dim currentUser As String = Environment.UserName
        'Dim userDomain As String = currentDomain & "\" & currentUser
        ''Dim siteValue As String
        ''Dim userValue As String

        'Dim dt As New DataTable("Properties")
        'Try
        '    dr = cmd.ExecuteReader
        '    If dr.HasRows = True Then

        '        dt.Load(dr)


        '    End If
        'Catch ex As Exception
        '    SQLExceptionManager(ex, modName, rtnName, cmd, "Connection String: " & cn.ConnectionString)
        '    dr.Close()
        '    Return False
        'Finally
        '    dr.Close()
        'End Try

        'Dim cnt As Integer
        '' Dim bfirst As Boolean = True
        ''Dim Arrop As New List(Of MQROptions.OptProperties)

        'If dt.Rows.Count <> 0 Then
        '    For Each objDataRow In dt.Rows
        '        Dim sqlStatment1 As String

        '        Dim sqlCount As String = "SELECT COUNT(*) FROM [PropertyDef] where [PropertyName]='" & objDataRow.item("PropertyName") & "'"
        '        cmd.CommandText = sqlCount
        '        Try
        '            cnt = cmd.ExecuteScalar
        '        Catch
        '        End Try
        '        If cnt > 1 Then    'cnt > 1 means  this is a MultiVal item
        '            Continue For
        '        End If


        '        sqlStatment1 = "SELECT * FROM [SingleVal] WHERE [category] = '" & objDataRow.item("Category") & _
        '                       "' and [PropertyName] = '" & objDataRow.item("PropertyName") & "' and ([User] = '" & userDomain.ToUpper & "' or  " & _
        '                       " [User] = '*GLOBAL*') ORDER BY [PropertyName]"

        '        cmd.CommandText = sqlStatment1
        '        Try
        '            dr = cmd.ExecuteReader

        '            If dr.HasRows = True Then
        '                If bfirst = True Then
        '                    i = OptPropArray.Count - 1
        '                    bfirst = False
        '                Else
        '                    ReDim Preserve OptPropArray(OptPropArray.Count)
        '                    i = OptPropArray.Count - 1
        '                End If
        '                While (dr.Read())
        '                    If OptPropArray(i).OptProp_Category = objDataRow.item("Category") And
        '                       OptPropArray(i).OptProp_PropertyName = objDataRow.item("PropertyName") Then   'case where both site and user overrides exist
        '                        If dr.Item("User") = "*GLOBAL*" Then
        '                            OptPropArray(i).OptProp_SiteValue = dr.Item("PropertyValue1")
        '                            OptPropArray(i).OptProp_UserId = "" 'leave blank if global value
        '                        Else
        '                            OptPropArray(i).OptProp_UserValue = dr.Item("PropertyValue1")
        '                            OptPropArray(i).OptProp_UserId = dr.Item("User")
        '                        End If
        '                    End If
        '                    LoadGridValues(OptPropArray(i), objDataRow, dr.Item("User"), dr.Item("PropertyValue1"))
        '                End While
        '                loadQueryGrid(OptPropArray, OptPropArray.Count - 1)  'last entry
        '            Else
        '                If bfirst = True Then
        '                    i = OptPropArray.Count - 1
        '                    bfirst = False
        '                Else

        '                    ReDim Preserve OptPropArray(OptPropArray.Count)
        '                    i = OptPropArray.Count - 1
        '                End If

        '                LoadGridValues(OptPropArray(i), objDataRow, "", "")
        '                loadQueryGrid(OptPropArray, OptPropArray.Count - 1)

        '            End If
        '        Catch ex As Exception
        '            SQLExceptionManager(ex, modName, rtnName, cmd, "Connection String: " & cn.ConnectionString)
        '            dr.Close()

        '            Return False
        '        Finally
        '            dr.Close()
        '        End Try
        '        Dim propValItem As New PropertyVal
        '        ReDim Preserve propVal.PropertyVal(i)
        '        AddItemToPropVal(OptPropArray(i), propValItem)
        '        propVal.PropertyVal(i) = propValItem
        '        rowCount += 1
        '    Next

        'End If

        ''test code - for serialize/deserialze datatables
        'Dim strxml As String = ""
        'SerializeDataTable(dt, strxml)  'DataTable("Properties")
        ''
        'SerializePropertyVal(propVal)   'object of type drPropertyValue
        ''end test
        'Return True
    End Function
    Private Sub LoadGridValues(ByRef OptPropItem As OptProp, objdatarow As DataRow, theUser As String, theValue As String)
        OptPropItem.OptProp_Category = objdatarow.Item("Category")
        OptPropItem.OptProp_PropertyName = objdatarow.Item("PropertyName")
        OptPropItem.OptProp_ValueNum = objdatarow.Item("ValueNum")
        OptPropItem.OptProp_PropertyType = objdatarow.Item("PropertyType")
        If IsDBNull(objdatarow.Item("DisplayName")) = False Then
            OptPropItem.OptProp_DisplayName = objdatarow.Item("DisplayName")
        End If
        If IsDBNull(objdatarow.Item("CADefaultValue")) = False Then
            OptPropItem.OptProp_CADefaultValue = objdatarow.Item("CADefaultValue")
        End If
        If IsDBNull(objdatarow.Item("EditType")) = False Then
            OptPropItem.OptProp_EditType = objdatarow.Item("EditType")
        End If
        If theUser <> "" Then
            Select Case theUser
                Case "*GLOBAL*"
                    OptPropItem.OptProp_SiteValue = theValue
                Case Else
                    OptPropItem.OptProp_UserValue = theValue
            End Select
        Else
            OptPropItem.OptProp_SiteValue = ""
            OptPropItem.OptProp_UserValue = ""
        End If


    End Sub
    Private Sub SaveGridValues(ByRef OptPropItem As OptProp, objdatarow As DataRow, theUser As String, theValue As String)
   
    End Sub
    Private Sub AddItemToPropVal(ByRef OptPropItem As OptProp, ByRef propVal As PropertyVal)

        propVal.Category = OptPropItem.OptProp_Category
        propVal.PropertyName = OptPropItem.OptProp_PropertyName
        propVal.ValueNum = OptPropItem.OptProp_ValueNum
        propVal.PropertyType = OptPropItem.OptProp_PropertyType
        propVal.CADefaultValue = OptPropItem.OptProp_CADefaultValue
        propVal.SiteValue = OptPropItem.OptProp_SiteValue
        propVal.UserValue = OptPropItem.OptProp_UserValue
        propVal.UserID = OptPropItem.OptProp_UserId

    End Sub

    Private Sub addtoArrOP_orig(ByRef OptPropItem As OptProp, ByRef arrop As List(Of MQROptions.OptProperties))
        Dim op As New MQROptions.OptProperties
        op.Category = OptPropItem.OptProp_Category
        op.PropertyName = OptPropItem.OptProp_PropertyName
        op.ValueNum = OptPropItem.OptProp_ValueNum
        op.PropertyType = OptPropItem.OptProp_PropertyType
        op.CADefaultValue = OptPropItem.OptProp_CADefaultValue
        op.SiteValue = OptPropItem.OptProp_SiteValue
        op.UserValue = OptPropItem.OptProp_UserValue
        arrop.Add(op)

    End Sub
    Private Function loadQueryGrid(ByVal optPropArray As OptProp(), ByVal rowCount As Integer, ByVal editlist As List(Of String)) ' ByRef opteditem As Options.OptionEditable)
        Dim rtnName As String = "LoadQueryGrid"
        Dim fontList As fontStruct


        '-- Read only Text Cell type definition
        Dim txtCT As FarPoint.Win.Spread.CellType.TextCellType = New FarPoint.Win.Spread.CellType.TextCellType
        txtCT.ReadOnly = True

        Dim fntCT As New myFont
        fntCT.DropDownButton = True

        '-- General Cell type definition
        Dim gnlCT As FarPoint.Win.Spread.CellType.GeneralCellType = New FarPoint.Win.Spread.CellType.GeneralCellType

        '-- Combo box with true/false options
        Dim trflCT As FarPoint.Win.Spread.CellType.ComboBoxCellType = New FarPoint.Win.Spread.CellType.ComboBoxCellType
        trflCT.Items = New String() {"True", "False"}
        '-- Combo box with Y/N options
        Dim ynCT As FarPoint.Win.Spread.CellType.ComboBoxCellType = New FarPoint.Win.Spread.CellType.ComboBoxCellType
        ynCT.Items = New String() {"Y", "N"}
        '-- Combo box with Yes/Ne options
        Dim yesnoCT As FarPoint.Win.Spread.CellType.ComboBoxCellType = New FarPoint.Win.Spread.CellType.ComboBoxCellType
        yesnoCT.Items = New String() {"Yes", "No"}

        '-- Numeric with no decimal places cell type definition
        Dim nbrCT As FarPoint.Win.Spread.CellType.NumberCellType = New FarPoint.Win.Spread.CellType.NumberCellType
        nbrCT.DecimalPlaces = 0

        '-- Numeric with no decimal places cell type definition
        Dim nbrroCT As FarPoint.Win.Spread.CellType.NumberCellType = New FarPoint.Win.Spread.CellType.NumberCellType
        nbrroCT.DecimalPlaces = 0
        nbrroCT.ReadOnly = True

        '-- Coler Picker cell type opens a a full dialog box and allows any color to be chosen.  Fills the entire cell
        '-- with the chosen color.
        Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
        cpCT.AllowFullOpen = True
        cpCT.DropDown = False
        cpCT.AnyColor = True
        cpCT.FullOpen = False
        cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.BoxedWithText

        '-- Listbox cell type Definition
        Dim lbCT As FarPoint.Win.Spread.CellType.ComboBoxCellType = New FarPoint.Win.Spread.CellType.ComboBoxCellType
        Dim editorListBox As System.Windows.Forms.ListBox = New System.Windows.Forms.ListBox()


        '-- Add a blank row at the bottom of the grid so you can add the new data each time
        fpsProperties.ActiveSheet.Rows.Add(rowCount, 1)

        '-- Protect the first 2 columns so they can't be edited see cell type definitions above.
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdPropNameCol).CellType = txtCT
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdDeliveredCol).CellType = txtCT
        If optPropArray(rowCount).OptProp_DisplayName = "" Then
            optPropArray(rowCount).OptProp_DisplayName = optPropArray(rowCount).OptProp_PropertyName
        End If
        'After this we have to change this so that when we save back to the single val table the
        'PropertyName field in the SingleVal table has the ProperyName field = to PropertyName field in PropertyDef
        'Right now PropertyName is getting the DisplayName value.
        'end of comments
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdDeliveredCol).CellType = txtCT
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdDeliveredCol).Value = optPropArray(rowCount).OptProp_CADefaultValue
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).CellType = txtCT
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = False            '-- SiteValue Has Been Modified
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).CellType = txtCT
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = False            '-- UserValue Has Been Modified

        'for all row types
        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdPropNameCol).Value = optPropArray(rowCount).OptProp_DisplayName

        Select Case optPropArray(rowCount).OptProp_PropertyType
            Case "General"
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then

                    ' If optPropArray(rowCount).OptProp_SiteValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = gnlCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = True
                Else
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = gnlCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_CADefaultValue
                End If
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = gnlCT
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                End If
            Case "Number"
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then
                    '  If optPropArray(rowCount).OptProp_SiteValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = nbrCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = True
                Else
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = nbrCT
                    'fpsProperties.ActiveSheet.Columns(grdGlobalChgCol).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = CInt(optPropArray(rowCount).OptProp_CADefaultValue)
                End If
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = nbrCT
                'fpsProperties.ActiveSheet.Columns(grdGlobalChgCol).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                End If
            Case "Font"
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then
                    ' If optPropArray(rowCount).OptProp_SiteValue <> "" Then     '-- A Site value is provided so use that
                    loadFont(optPropArray(rowCount).OptProp_SiteValue, fontList)
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue 'fontList.font_Family
                    Dim fstyle As System.Drawing.FontStyle
                    fstyle = getFontStyleInt(fontList.font_Bold, fontList.font_Italic, False)
                    Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size, fstyle)
                    Dim ft As New myFont
                    ft.DropDownButton = True
                    ft.myFontDialog.Font = f
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ft
                Else                                                       '-- No Site Value use the CA Default Value
                    loadFont(optPropArray(rowCount).OptProp_CADefaultValue, fontList)
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_CADefaultValue 'fontList.font_Family
                    Dim fstyle As System.Drawing.FontStyle
                    fstyle = getFontStyleInt(fontList.font_Bold, fontList.font_Italic, False)
                    Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size, fstyle)
                    Dim ft As New myFont
                    ft.DropDownButton = True
                    ft.myFontDialog.Font = f
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ft

                    'If fontList.font_Bold = True Then
                    '    Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size)
                    '    Dim ft As New myFont
                    '    ft.DropDownButton = True
                    '    ft.myFontDialog.Font = f
                    '    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ft
                    'Else
                    '    Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size)
                    '    Dim ft As New myFont
                    '    ft.DropDownButton = True
                    '    ft.myFontDialog.Font = f
                    '    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ft
                    'End If

                End If
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then
                    ' If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    loadFont(optPropArray(rowCount).OptProp_UserValue, fontList)
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_UserValue 'fontList.font_Family
                    Dim fstyle As System.Drawing.FontStyle
                    fstyle = getFontStyleInt(fontList.font_Bold, fontList.font_Italic, False)
                    Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size, fstyle)
                    Dim ft As New myFont
                    ft.DropDownButton = True
                    ft.myFontDialog.Font = f
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ft

                    '    fpsProperties.ActiveSheet.Cells(rowCount, grdOverrideCol).Value = fontList.font_Family
                    '    If fontList.font_Bold = True Then
                    '        Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size, FontStyle.Bold)
                    '        Dim ft As New myFont
                    '        ft.DropDownButton = True
                    '        ft.myFontDialog.Font = f
                    '        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = ft
                    '    Else
                    '        Dim f = New System.Drawing.Font(fontList.font_Family, fontList.font_Size)
                    '        Dim ft As New myFont
                    '        ft.DropDownButton = True
                    '        ft.myFontDialog.Font = f
                    '        fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = ft
                    '    End If
                End If
                'fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = fntCT
                'fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                'If optPropArray(rowCount).OptProp_UserValue <> "" Then
                '    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                'End If

            Case "Boolean"
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then
                    '    If optPropArray(rowCount).OptProp_SiteValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = trflCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = True
                Else
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = trflCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_CADefaultValue
                End If
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = trflCT
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                End If
            Case "YesNo"
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then
                    '  If optPropArray(rowCount).OptProp_SiteValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = yesnoCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = True
                Else
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = yesnoCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_CADefaultValue
                End If
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = yesnoCT
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                End If
            Case "YN"
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then

                    ' If optPropArray(rowCount).OptProp_SiteValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ynCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = True
                Else
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = ynCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_CADefaultValue
                End If
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = ynCT
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                End If
            Case "Listbox"
                '-- Load list box 
                'loadTextEditors(editorListBox, optPropArray(rowCount).OptProp_EditType)
                loadEditListBox(editorListBox, editlist)
                lbCT.ListControl = editorListBox
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).Value = optPropArray(rowCount).OptProp_UserValue
                If optPropArray(rowCount).OptProp_UserValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdUserChgCol).Value = True
                End If
                If optPropArray(rowCount).OptProp_SiteValue <> optPropArray(rowCount).OptProp_CADefaultValue Then
                    ' If optPropArray(rowCount).OptProp_SiteValue <> "" Then
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = lbCT
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_SiteValue
                    fpsProperties.ActiveSheet.Cells(rowCount, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalChgCol).Value = True
                Else
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).CellType = lbCT
                    ''-- Load list box 
                    'loadTextEditors(editorListBox, optPropArray(rowCount).OptProp_EditType)
                    'lbCT.ListControl = editorListBox
                    fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value = optPropArray(rowCount).OptProp_CADefaultValue
                End If
                fpsProperties.ActiveSheet.Cells.Get(rowCount, grdOverrideCol).CellType = lbCT


        End Select


        Return True
    End Function
    Private Function loadEditListBox(ByVal editorsListBox As ListBox, ByVal editlist As List(Of String)) As Boolean
        ' Private Function loadEditListBox(ByVal editorsListBox As ListBox, ByVal propListName As String, ByRef opteditem As Options.OptionEditable) As Boolean


        Dim rtnName As String = " loadEditListBox"
        For i = 0 To editlist.Count - 1
            editorsListBox.Items.Add(editlist(i))
        Next
        Return True
    End Function

    Private Function loadTextEditors(ByRef editorsListBox, ByVal propListName) As Boolean
        Dim rtnName As String = "LoadTextEditors"



        Dim sqlStatement As String = ""
        Dim cmd As New OleDbCommand
        Dim dr As OleDbDataReader
        Dim editorName As String = ""
        Dim i As Integer = 0

        sqlStatement = "SELECT * FROM editList where [ListName] = '" & propListName & "'"
        Try
            cmd.Connection = cn
            cmd.CommandText = sqlStatement
            If cn.State = ConnectionState.Closed Then
                cn.Open()
            End If


            dr = cmd.ExecuteReader
            If dr.HasRows = True Then
                While (dr.Read())
                    editorName = dr("ValidValue").ToString
                    editorsListBox.Items.Add(editorName)
                    i += 1
                End While
            End If
        Catch ode As OleDbException
            SQLExceptionManager(ode, modName, rtnName, cmd, "Connection String: " & cn.ConnectionString)
            cn.Close()
            Return False
        Catch ex As Exception
            SQLExceptionManager(ex, modName, rtnName, cmd, "Connection String: " & cn.ConnectionString)
            cn.Close()
            Return False
        Finally
            'cn.Close()
        End Try
        Return True
    End Function
    Public Function loadFont(ByRef fontField As String, ByRef fontList As fontStruct) As Boolean

        Dim i As Integer
        'To Do: fix fonts
        'default font values - until font as working better
        fontList.font_Size = 9
        fontList.font_Bold = False
        fontList.font_Italic = False

        Try
            Dim tempArray() As String = fontField.Split(",")
            For i = 0 To tempArray.Length - 1
                Select Case i
                    Case 0
                        fontList.font_Family = tempArray(0)
                    Case 1
                        fontList.font_Size = tempArray(1)
                    Case 2
                        fontList.font_Bold = Convert.ToBoolean(tempArray(2))
                    Case 3
                        fontList.font_Italic = Convert.ToBoolean(tempArray(3))
                End Select
            Next
        Catch ex As Exception
            MsgBox("error in load font")
        End Try

        Return True
    End Function

    Public Function getFontStyleInt(FontBold As Boolean, FontItalic As Boolean, FontUnderline As Boolean) As Integer
        Dim fontInt As Integer
        Try

            If FontBold = True Then
                fontInt = fontInt Or FontStyle.Bold
            End If

            If FontItalic = True Then
                fontInt = fontInt Or FontStyle.Italic
            End If

            If FontUnderline = True Then
                fontInt = fontInt Or FontStyle.Underline
            End If
            getFontStyleInt = fontInt
        Catch
            'any error - return FontStyle.Regular
            getFontStyleInt = FontStyle.Regular
        End Try
    End Function
    Private Function SaveQueryGrid(ByVal optPropArray As OptProp(), ByVal arrayRow As Integer, ByVal rowCount As Integer)
        Dim rtnName As String = "SaveQueryGrid"

        If fpsProperties.ActiveSheet.Cells.Get(rowCount, grdPropNameCol).Value = optPropArray(arrayRow).OptProp_DisplayName Then
            If IsNothing(fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value) = False Then
                optPropArray(arrayRow).OptProp_SiteValue = fpsProperties.ActiveSheet.Cells.Get(rowCount, grdGlobalCol).Value.ToString
            End If
        Else
            'an error occurred
            MsgBox("Bug?? here")
        End If

        'in case we need to save by row type
        Select Case optPropArray(rowCount).OptProp_PropertyType
            Case "General"
            Case "Number"
            Case "Font"
            Case "Boolean"
            Case "YesNo"
            Case "YN"
            Case "Listbox"
        End Select


        Return True
    End Function

    Private Function calculateColWidth()
        Dim rtnName As String = "calculateColWidth"
        fpsProperties.Width = Me.Width - 25
        '-- Calculate Column width based on the number of columns displayed
        Dim currentWidth As Double = 0
        
        fpsProperties.ActiveSheet.Columns(0).Width = 160

        Dim dataGridWidth As Double = fpsProperties.Width '- 20
        For idx = 0 To fpsProperties.ActiveSheet.Columns.Count - 1
            
            Dim newWidth As Integer = (dataGridWidth - fpsProperties.ActiveSheet.Columns(0).Width) / (displayedCols - 1)

            If idx >= 1 Then
                Try
                    fpsProperties.ActiveSheet.Columns(idx).Width = newWidth - 10
                Catch ex As Exception
                    fpsProperties.ActiveSheet.Columns(idx).Width = 15
                End Try
            Else
                'fpsProperties.ActiveSheet.Columns(idx).Width = newWidth
            End If
        Next
        Return True
    End Function
    Private Function calculateGridHeight()
        Dim rtnName As String = "calculateGridWidth"

        fpsProperties.Height = Me.Height - 150

        Return True
    End Function
    Private Sub fpsProperties_CellClick(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.CellClickEventArgs) Handles fpsProperties.CellClick
        Dim rtnName As String = "fpsProperties_CellClick"
        Dim tmpString As String = ""
        Dim loc As Integer
        Dim filename As String

        If Not e.ColumnHeader Then
            If e.Column > grdDeliveredCol Then
                Dim CellType As String = fpsProperties.ActiveSheet.GetCellType(e.Row, e.Column).ToString
                If CellType <> "myFont" Then
                    tmpString = fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Value
                End If
                Select Case CellType
                    Case "myFont"
                        tmpString = fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Value
                        Debug.Print("tmpstring" & tmpString)
                        Dim fontlist As New fontStruct
                        loadFont(tmpString, fontlist)
                        Dim fstyle As System.Drawing.FontStyle
                        fstyle = getFontStyleInt(fontlist.font_Bold, fontlist.font_Italic, False)
                        Dim f = New System.Drawing.Font(fontlist.font_Family, fontlist.font_Size, fstyle)
                        Dim ft As New myFont
                        ft.DropDownButton = True
                        ft.myFontDialog.Font = f
                    Case "ColorPickerCellType"
                        'TODO: Write ColorPickerCellType code here
                    Case Else
                        If e.Column = grdOverrideCol And fpsProperties.ActiveSheet.Cells.Get(e.Row, grdOverrideCol).Value = "" Then
                            fpsProperties.ActiveSheet.Cells.Get(e.Row, grdOverrideCol).Value = fpsProperties.ActiveSheet.Cells.Get(e.Row, grdDeliveredCol).Value
                            fpsProperties.ActiveSheet.Cells(e.Row, grdUserChgCol).Value = True
                            tmpString = fpsProperties.ActiveSheet.Cells(e.Row, grdOverrideCol).Value
                            filename = ""
                            fbdFinder.SelectedPath = ""
                        End If
                        If tmpString <> "" Then
                            If tmpString.Contains(":\") Then
                                loc = tmpString.LastIndexOf(".")
                                If loc > 0 Then
                                    '-- strip off file name
                                    loc = tmpString.LastIndexOf("\")
                                    filename = tmpString.Substring(loc + 1)
                                    fbdFinder.SelectedPath = tmpString.Substring(0, loc)
                                Else
                                    '-- just use path
                                    fbdFinder.SelectedPath = fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Value
                                End If
                                fbdFinder.Description = "Locate Path"
                                Try
                                    fbdFinder.ShowDialog()
                                    If filename = "" Then
                                        fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Value = fbdFinder.SelectedPath
                                    Else
                                        fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Value = fbdFinder.SelectedPath & "\" & filename
                                    End If
                                Catch ex As Exception
                                    'TODO: Code exception for try finder here
                                End Try
                            End If
                        End If
                End Select

            End If
        End If
    End Sub

    Private Sub fpsProperties_Change(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.ChangeEventArgs) Handles fpsProperties.Change

        If e.Column = grdGlobalCol Then
            If fpsProperties.ActiveSheet.Cells.Get(e.Row, grdGlobalCol).Value = fpsProperties.ActiveSheet.Cells.Get(e.Row, grdDeliveredCol).Value Then
                fpsProperties.ActiveSheet.Cells.Get(e.Row, grdGlobalCol).Value = fpsProperties.ActiveSheet.Cells.Get(e.Row, grdDeliveredCol).Value
                fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Font = New Font(DefaultFont, FontStyle.Regular)
                fpsProperties.ActiveSheet.Cells.Get(e.Row, grdGlobalChgCol).Value = False
            Else
                fpsProperties.ActiveSheet.Cells(e.Row, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Bold)
                fpsProperties.ActiveSheet.Cells.Get(e.Row, grdGlobalChgCol).Value = True
            End If
        End If
        If e.Column = grdOverrideCol Then
            If fpsProperties.ActiveSheet.Cells.Get(e.Row, grdOverrideCol).Value = fpsProperties.ActiveSheet.Cells.Get(e.Row, grdDeliveredCol).Value Then
                'fpsProperties.ActiveSheet.Cells.Get(e.Row, grdOverrideCol).Value = ""  'if it is = to the default value set to nothing
                fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Font = New Font(DefaultFont, FontStyle.Regular)
                fpsProperties.ActiveSheet.Cells.Get(e.Row, grdUserChgCol).Value = True
            Else
                fpsProperties.ActiveSheet.Cells(e.Row, e.Column).Font = New Font(DefaultFont, FontStyle.Bold)
                fpsProperties.ActiveSheet.Cells.Get(e.Row, grdUserChgCol).Value = True
            End If
        End If
    End Sub


    Private Sub fpsProperties_ColumnWidthChanged(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.ColumnWidthChangedEventArgs) Handles fpsProperties.ColumnWidthChanged
        '-- Allow the text in the Column headers to wrap so it is all displayed
        fpsProperties.ActiveSheet.ColumnHeader.Rows(0).Height = fpsProperties.ActiveSheet.ColumnHeader.Rows(0).GetPreferredHeight()

    End Sub


    Private Sub mnuShowDefaultOpts_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuDisplayShowDefaultOpts.Click
        If mnuDisplayShowDefaultOpts.Checked = False Then
            mnuDisplayShowDefaultOpts.Checked = True
            If CategoryRow.category = "MICSQueryIni" Then
                displayedCols = 4
            Else
                displayedCols = 3
            End If
            fpsProperties.ActiveSheet.ColumnHeader.Columns(grdDeliveredCol).Visible = True
        Else
            mnuDisplayShowDefaultOpts.Checked = False
            If CategoryRow.category = "MICSQueryIni" Then
                displayedCols = 3
            Else
                displayedCols = 2
            End If

            fpsProperties.ActiveSheet.ColumnHeader.Columns(grdDeliveredCol).Visible = False
        End If
        '-- Calcuate column widte based on displayed columnes
        calculateColWidth()
    End Sub

    Private Sub mnuResetGlobalOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuResetGlobalOptions.Click
        Dim result As MsgBoxResult
        result = MsgBox("Are you sure you want to reset all you global options." & vbCrLf & "This will delete all existing site options" & _
                        " and reset them to the CA delivered defaults.", vbYesNo)
        Select Case result
            Case MsgBoxResult.Yes
                '-- Copy default values from default value column and set change indicator to false
                For i As Integer = 0 To fpsProperties.ActiveSheet.Rows.Count - 1
                    fpsProperties.ActiveSheet.Cells.Get(i, grdGlobalCol).Value = fpsProperties.ActiveSheet.Cells.Get(i, grdDeliveredCol).Value
                    fpsProperties.ActiveSheet.Cells(i, grdGlobalCol).Font = New Font(DefaultFont, FontStyle.Regular)
                    fpsProperties.ActiveSheet.Cells.Get(i, grdGlobalChgCol).Value = False
                Next
            Case MsgBoxResult.No
                Exit Sub
        End Select

    End Sub

    Private Sub mnuResetUserOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuResetUserOptions.Click
        For i As Integer = 0 To fpsProperties.ActiveSheet.Rows.Count - 1
            fpsProperties.ActiveSheet.Cells(i, grdOverrideCol).Value = ""
            fpsProperties.ActiveSheet.Cells(i, grdOverrideCol).Font = New Font(DefaultFont, FontStyle.Regular)
            fpsProperties.ActiveSheet.Cells(i, grdUserChgCol).Value = False
        Next
        Try
            'TODO: Write Code to delete from database records for the active INI for the current user
        Catch ex As Exception

        End Try
    End Sub

    Private Sub cmdFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdFind.Click
        fpsProperties.SearchWithDialog(0, "", False, False, False, False, 0, 0)
    End Sub

    Private Sub cmdApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdApply.Click
        Dim domainUser As String = Environment.UserDomainName & "\" & Environment.UserName.ToUpper
        Dim gridrow As Integer = 0
        For i = 0 To OptPropArray.Count - 1
            'If OptPropArray(i).OptProp_UIUpdateable = True Then
            SaveQueryGrid(OptPropArray, i, gridrow)
            gridrow = gridrow + 1
            'End If

        Next

        Update_OptionsSingle("*GLOBAL*")
        'Update_OptionsSingle(domainUser)
        'For i As Integer = 0 To fpsProperties.ActiveSheet.RowCount - 1
        '    Debug.Print("Data Values " & fpsProperties.ActiveSheet.Cells(i, 0).Value & Chr(10) & fpsProperties.ActiveSheet.Cells(i, 1).Value)
        'Next

    End Sub
    Private Sub Update_OptionsSingle(theuser As String)
        '  PrintDebugInfo("Singleval")

        Dim thesql As String
        Dim cmdRead As New OleDbCommand
        Dim cmdInsert As New OleDbCommand
        Dim cmdUpdate As New OleDbCommand
        Dim CAvalue As String
        Dim SiteValue As String
        Dim UserValue As String
        Dim CompareValue As String
        Dim NewValue As String
        Dim dr As OleDbDataReader
        Dim SingleVals(OptPropArray.Count - 1) As Options.SingleValRow



        For i = 0 To OptPropArray.Count - 1
            SingleVals(i) = New Options.SingleValRow
            SingleVals(i).category = OptPropArray(i).OptProp_Category
            SingleVals(i).propertyName = OptPropArray(i).OptProp_PropertyName
            SingleVals(i).user = OptPropArray(i).OptProp_UserId
            If theuser = "*GLOBAL*" Then
                If OptPropArray(i).OptProp_SiteValue <> OptPropArray(i).OptProp_CADefaultValue Then
                    SingleVals(i).propertyValue1 = OptPropArray(i).OptProp_SiteValue
                Else
                    SingleVals(i).propertyValue1 = Nothing 'vbNullString
                End If
            Else
                If OptPropArray(i).OptProp_SiteValue <> Nothing Then 'vbNull Then
                    If OptPropArray(i).OptProp_UserValue <> OptPropArray(i).OptProp_SiteValue Then
                        SingleVals(i).propertyValue1 = OptPropArray(i).OptProp_UserValue
                    End If
                Else
                    If OptPropArray(i).OptProp_UserValue <> OptPropArray(i).OptProp_CADefaultValue Then
                        SingleVals(i).propertyValue1 = OptPropArray(i).OptProp_UserValue
                    End If
                End If
            End If

        Next
        'call the server to update
        Dim updOK As Boolean
        updOK = frmServerComm.svrUpdateOptions(SingleVals)

        'For i = 0 To OptPropArray.Count - 1


        '    '-- Actually Read the information to load the grid based on the Subcategory
        '    thesql = "SELECT * FROM [SingleVal] WHERE [category] = '" & OptPropArray(i).OptProp_Category & _
        '                       "' " & " and " & " [User] = '" & theuser & "'" & " and [PropertyName] = '" & OptPropArray(i).OptProp_PropertyName & "'"

        '    cmdRead.Connection = cn
        '    cmdInsert.Connection = cn
        '    cmdUpdate.Connection = cn


        '    cmdRead.CommandText = thesql
        '    If cn.State = ConnectionState.Closed Then
        '        cn.Open()
        '    End If
        '    CAvalue = fpsProperties.ActiveSheet.Cells(i, 1).Value
        '    SiteValue = fpsProperties.ActiveSheet.Cells(i, 2).Value
        '    UserValue = fpsProperties.ActiveSheet.Cells(i, 3).Value

        '    Select Case theuser
        '        Case "*GLOBAL*"
        '            CompareValue = CAvalue
        '            NewValue = SiteValue
        '        Case Else
        '            CompareValue = SiteValue
        '            NewValue = UserValue
        '    End Select


        '    Try
        '        dr = cmdRead.ExecuteReader
        '        If dr.HasRows = True Then
        '            If NewValue <> CompareValue Then
        '                Update_SingleVal(i, theuser, NewValue, cn)
        '            Else
        '                Delete_SingleVal(i, theuser, cn)
        '            End If
        '        Else
        '            If NewValue <> Nothing Then
        '                If NewValue <> CompareValue Then
        '                    Insert_Singleval(i, theuser, NewValue, cn)
        '                End If
        '            End If
        '        End If
        '        dr.Close()
        '    Catch ex As Exception

        '    End Try
        'Next


    End Sub
    Private Sub update_uservalues()

    End Sub
    Private Sub Update_SingleVal(i As Integer, theuser As String, thevalue As String, cmdCn As OleDbConnection)
        Dim cmdstr As String
        Dim thecmd As New OleDbCommand
        thecmd.Connection = cn

        cmdstr = "UPDATE " & "[SingleVal]" & _
         " SET [PROPERTYVALUE1] = '" & thevalue & "'" & _
        " WHERE [Category] = '" & OptPropArray(i).OptProp_Category & _
                              "' " & " and " & " [User] = '" & theuser & "'" & _
                              " and [PropertyName] = '" & OptPropArray(i).OptProp_PropertyName & "'"
        thecmd.CommandText = cmdstr
        'thecmd.Parameters.Add("PROPERTYVAL1", OleDbType.Char, 255)
        'thecmd.Parameters(0).Value = thevalue
        Try
            ' thecmd.Prepare()
            thecmd.ExecuteNonQuery()
        Catch
            Debug.Print("error: " & thecmd.CommandText.Length & thecmd.CommandText)
        End Try

    End Sub
    Private Sub Insert_Singleval(i As Integer, theUser As String, thevalue As String, cmdCn As OleDbConnection)
        Dim cmdstr As String
        Dim thecmd As New OleDbCommand
        thecmd.Connection = cn
        cmdstr = "INSERT INTO " & "[SingleVal]" & _
                                        " ([CATEGORY], [PROPERTYNAME], [PROPERTYVALUE1], [USER])" & _
                                        " VALUES  ( ?,?,?,?)"
        thecmd.CommandText = cmdstr
        thecmd.Parameters.Add("CATEGORY", OleDbType.Char, 255)
        thecmd.Parameters.Add("PROPERTYNAME", OleDbType.Char, 255)
        thecmd.Parameters.Add("PROPERTYVALUE1", OleDbType.Char, 255)
        thecmd.Parameters.Add("USER", OleDbType.Char, 255)
        thecmd.Parameters(0).Value = OptPropArray(i).OptProp_Category
        thecmd.Parameters(1).Value = OptPropArray(i).OptProp_PropertyName
        thecmd.Parameters(2).Value = thevalue  ' OptPropArray(i).OptProp_SiteValue
        thecmd.Parameters(3).Value = theUser   '"*GLOBAL*" 'OptPropArray(i).OptProp_User
        Try
            thecmd.Prepare()
            thecmd.ExecuteNonQuery()
        Catch
            Debug.Print("error: " & thecmd.CommandText.Length & thecmd.CommandText)
        End Try
    End Sub
    Private Sub Delete_SingleVal(i As Integer, theUser As String, cmdCn As OleDbConnection)
        Dim cmdstr As String
        Dim thecmd As New OleDbCommand
        thecmd.Connection = cn

        cmdstr = "Delete FROM [SingleVal] WHERE [Category] = '" & OptPropArray(i).OptProp_Category & _
                              "' " & " and " & " [User] = '" & theUser & "'" & " and [PropertyName] = '" & OptPropArray(i).OptProp_PropertyName & "'"

        'cmdstr = "DELETE FROM " & "[SingleVal]" & _
        '                          " WHERE [PROPERTYVALUE1] = PROPERTYVAL1 "
        thecmd.CommandText = cmdstr
        Try
            thecmd.Prepare()
            thecmd.ExecuteNonQuery()
        Catch
            Debug.Print("error: " & thecmd.CommandText.Length & thecmd.CommandText)
        End Try
    End Sub
    Private Sub PrintDebugInfo(InfoType As String)
        Try
            Select Case InfoType.ToUpper
                Case "SINGLEVAL"
                    For i As Integer = 0 To fpsProperties.ActiveSheet.RowCount - 1
                        Debug.Print("ROW " & i & ":" & fpsProperties.ActiveSheet.Cells(i, 0).Value & _
                                    "   ca: " & fpsProperties.ActiveSheet.Cells(i, 1).Value & _
                                    " site: " & fpsProperties.ActiveSheet.Cells(i, 2).Value & _
                                    " user: " & fpsProperties.ActiveSheet.Cells(i, 3).Value)
                    Next
            End Select
        Catch
            Exit Sub ' if there's a problem just get out
        End Try

    End Sub
    Public Function SerializeDataTable(ByRef dtName As DataTable, ByRef strXMLOut As String) As Boolean
        Dim rtnname As String = "SerializeDataTable"
        Try
            dtName.RemotingFormat = SerializationFormat.Xml
            Dim bf As New BinaryFormatter
            Dim ms1 As Stream = New MemoryStream(32000)
            Dim serializer As New XmlSerializer(GetType(DataTable))
            serializer.Serialize(ms1, dtName)

            'print XML string in the immediate window
            ms1.Position = 0
            Dim SR1 = New StreamReader(ms1)
            Dim myStr As String = SR1.ReadToEnd()
            PrintXML(myStr, True)

            'now take mystr and turn it back into a datatabale 
            Dim dtnew As DataTable
            dtnew = serializer.Deserialize(New StringReader(myStr))
            PrintDT(dtName, dtnew, True)
            Return True
        Catch ex As Exception
            Debug.Print("error: cannot serialize datatable")
            Return False
        End Try
    End Function
    Sub SerializePropertyVal(propval As drPropertyVal)
        Dim ms1 As Stream = New MemoryStream(32000)
        Dim serializer As New XmlSerializer(GetType(drPropertyVal))
        serializer.Serialize(ms1, propval)

        'print XML string in the immediate window
        ms1.Position = 0
        Dim SR1 = New StreamReader(ms1)
        Dim myStr As String = SR1.ReadToEnd()
        PrintXML(myStr, True)

        'next Deserialize it 
        DeserializePropertyVal(myStr)
    End Sub
    Sub DeserializePropertyVal(XMLstr As String)
        Dim propVal As New drPropertyVal
        Dim serializer As New XmlSerializer(GetType(drPropertyVal))
        'now take mystr put it back into the class 
        propVal = serializer.Deserialize(New StringReader(XMLstr))
        propVal.PrintClassToDbg()

    End Sub
    Sub PrintXML(ByRef xmlstring As String, bprint As Boolean)

        Debug.Print("---------------------------------")
        Debug.Print("Print the XML to the debug window. " & Now)
        If bprint = True Then
            Debug.Print("xmlstring.Length = " & xmlstring.Length.ToString)
            Debug.Print(xmlstring)
        End If
    End Sub
    Sub PrintDT(ByVal inDataTbl1 As DataTable, ByVal inDataTbl2 As DataTable, ByVal bprint As Boolean)
        Debug.Print("Print the DataTable1 and DataTable 2 to the debug window. " & Now)
        Dim i As Integer
        For i = 0 To inDataTbl1.Rows.Count - 1
            Debug.Print("DataTable Row:" & i)
            If bprint = True Then
                For j = 0 To inDataTbl1.Columns.Count - 1
                    Debug.Print("row: " & j & " " & inDataTbl1.Columns(j).ColumnName & " " & inDataTbl1.Rows(i).Item(j) & " / " & inDataTbl2.Rows(i).Item(j).ToString)
                Next

            End If
        Next
    End Sub

    Private Sub frmINIOptions_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
        'fpsProperties.Width = Me.Width - 25
        calculateColWidth()
        calculateGridHeight()
    End Sub
End Class
Class myFont
    Inherits FarPoint.Win.Spread.CellType.GeneralCellType
    Public myFontDialog As New FontDialog
    Shared f As Font

    'Public Overrides Sub PaintCell(ByVal g As System.Drawing.Graphics, ByVal r As System.Drawing.Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, _
    ' ByVal zoomFactor As Single)
    '    Dim newR As New Rectangle(r.X, r.Y, r.Width, r.Height)
    '    Dim rm As New System.Resources.ResourceManager(GetType(FarPoint.Win.IElement))
    '    Dim b As New FarPoint.Win.ButtonElement()

    '    Dim f1 As Font = myFontDialog.Font

    '    'If (f1 IsNot Nothing) Then
    '    '    appearance.Font = f1
    '    '    MyBase.PaintCell(g, newR, appearance, f1, isSelected, isLocked, zoomFactor)
    '    'Else
    '    '    MyBase.PaintCell(g, newR, appearance, value, isSelected, isLocked, zoomFactor)
    '    'End If
    'End Sub
    Public Overrides Function IsReservedLocation(ByVal g As System.Drawing.Graphics, ByVal x As Integer, ByVal y As Integer, ByVal rc As System.Drawing.Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, _
     ByVal zoomFactor As Single) As Object
        Dim rectButton As New Rectangle(rc.X + rc.Width - SystemInformation.VerticalScrollBarWidth, rc.Y, SystemInformation.VerticalScrollBarWidth, rc.Height)
        If (rectButton.Contains(New Point(x, y))) Then
            Return Me
        Else
            Return Nothing
        End If
    End Function
    Public Overrides Function GetEditorValue() As Object
        Return MyBase.GetEditorValue

    End Function
    Public Overrides Sub StartEditing(ByVal e As System.EventArgs, ByVal selectAll As Boolean, ByVal autoClipboard As Boolean)
        Dim tmpstring As String
        tmpstring = MyBase.GetEditorValue
        Debug.Print("tmpstring" & tmpString)
        Dim fontlist As New fontStruct
        loadFont(tmpstring, fontlist)
        Dim fstyle As System.Drawing.FontStyle
        fstyle = getFontStyleInt(fontlist.font_Bold, fontlist.font_Italic, False)
        Dim f = New System.Drawing.Font(fontlist.font_Family, fontlist.font_Size, fstyle)
        Dim ft As New myFont
        ft.DropDownButton = True
        ft.myFontDialog.Font = f

        If (f IsNot Nothing) Then
            myFontDialog.Font = f

            myFontDialog.ShowEffects = False
            myFontDialog.ShowColor = True
            myFontDialog.MinSize = 6
        End If
        myFontDialog.ShowDialog()
        f = myFontDialog.Font
        MyBase.SetEditorValue(f.Name & "," & f.Size & "," & f.Bold & "," & f.Italic)
        MyBase.StopEditing()
    End Sub
    Public Function returnfont() As System.Drawing.Font
        Return f
    End Function
    
End Class